unit Main;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, ExtCtrls, Menus, Cards;

type
  TMainForm = class(TForm)
    player1: TPlayingCard;
    player2: TPlayingCard;
    player3: TPlayingCard;
    player4: TPlayingCard;
    player5: TPlayingCard;
    butDeal: TButton;
    butHit: TButton;
    butHold: TButton;
    Label1: TLabel;
    procedure ShuffleDeck;
    procedure DealCards;
    procedure FormCreate(Sender: TObject);
    function GetCard: byte;
    procedure butDealClick(Sender: TObject);
    procedure butHitClick(Sender: TObject);
    procedure butHoldClick(Sender: TObject);
  end;

var
  MainForm: TMainForm;
  CardDeck: Array[1..52] of byte;
  CardPos, PlayerPos: Byte;

implementation

{$R *.DFM}

procedure TMainForm.ShuffleDeck;
var
    suba: word;
    rand1, rand2, tempswap: byte;
begin
    randomize;

    for suba := 1 to 52 do
        CardDeck[suba] := suba;

    for suba := 1 to 5000 do
    begin
        rand1 := random(52) + 1;
        rand2 := random(52) + 1;
        tempswap := CardDeck[rand1];
        CardDeck[rand1] := CardDeck[rand2];
        CardDeck[rand2] := tempswap;
    end;

    CardPos := 1;
end;

function TMainForm.GetCard: Byte;
begin
    GetCard := CardDeck[CardPos];
    CardPos := CardPos + 1;
    If CardPos = 53 then
        ShuffleDeck;
end;

procedure TMainForm.DealCards;
begin
    Player3.Visible := False;
    Player4.Visible := False;
    Player5.Visible := False;

    Player1.CardSequence := GetCard;
    Player2.CardSequence := GetCard;
    Player3.CardSequence := GetCard;
    Player4.CardSequence := GetCard;
    Player5.CardSequence := GetCard;

    PlayerPos := 3;

    butHit.Enabled := true;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
     ShuffleDeck;
end;

procedure TMainForm.butDealClick(Sender: TObject);
begin
    DealCards;
end;

procedure TMainForm.butHitClick(Sender: TObject);
begin
     If PlayerPos = 3 then
         Player3.Visible := true;
     If PlayerPos = 4 then
         Player4.Visible := true;
     If PlayerPos = 5 then
     begin
         Player5.Visible := true;
         butHit.Enabled := false;
     end;

     PlayerPos := PlayerPos + 1;
end;

procedure TMainForm.butHoldClick(Sender: TObject);
begin
    close;
end;

end.
